@echo off
rem ===========================================================================
echo EAAddinSetup.bat Version 3.13
rem Copyright(C) 2010-2020 Sparx Systems Japan Co., Ltd. All rights Reserved.
rem ===========================================================================
rem Parameter
rem NA    : Install
rem /u    : Uninstall
rem /u /f : Uninstall Force
rem ===========================================================================

setlocal

set result=0

rem
IF not "%1"=="/u" (
 set SetupKind=add
 set /a delCounter=-1
 set Message=register
 set SkipRequireProcess=0
) ELSE (
 set SetupKind=del
 set /a delCounter=1
 set Message=remove
 IF not "%2"=="/f" (
   set SkipRequireProcess=0
 ) ELSE (
   set SkipRequireProcess=1
 )
)

rem
for /f "tokens=4,5,6,7,8,9,10*" %%i in ('%windir%\system32\reg.exe query "HKCU\Software\Sparx Systems\EA400\EA" /v "Install Path"') do set EAInstallPath=%%i %%j %%k %%l %%m %%n %%o
:LOOP
IF "%EAInstallPath%"=="" (goto err1)
IF not "%EAInstallPath:~-1%"==" " (GOTO NEXT) else set EAInstallPath=%EAInstallPath:~0,-1%
GOTO LOOP
:NEXT
IF not EXIST "%EAInstallPath%" (goto err1)
IF not EXIST "%EAInstallPath%\EA.exe" (goto err1)

rem
"%EAInstallPath%\EA.exe" /register
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKCU\Software\Sparx Systems\EA400\EA" /v "Version"') do set EAVersionFull=%%i
set EAVersion=%EAVersionFull:~0,2%
set EAVersion=%EAVersion:.=%
set EABuild=%EAVersionFull:~-4%
set EABuild=%EABuild:.=%

rem
copy nul "%EAInstallPath%\addin.tmp" > nul 2>&1
IF not %errorlevel%==0 (goto err2)
del /F "%EAInstallPath%\addin.tmp"

rem
cd /d %~dp0
set CurrentPath=%cd%

rem

rem
IF %SetupKind%==add (
 for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
) ELSE (
rem
 IF %delCounter%==1 (
  for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
  set /a delCounter=delCounter+1
  for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
))

rem
echo:
IF %result%==0 (
 echo -----The Add-in is successfully %Message%ed.-----
) ELSE (
 echo -----Failed to %Message% the Add-in.-----
 echo Troubleshooting https://www.sparxsystems.jp/en/EAAddinSetupEn.htm#trouble
)
pause
exit /b %result%

rem
:START
if %result%==2 (goto end_repeat)

rem
set Header=""
set Command=""
set AddinName=""
set FileName=""
set DLLInfo=""
set RegValue=""
set NoCopy=""

rem
set Header=%1
set Command=%2
set AddinName=%3
set FileName=%4
set DLLInfo=%5
set RegValue=%6
set NoCopy=%7

IF not "%Header%"=="-" (goto end_repeat)
IF %Command%==reg (goto regProcess)
IF %Command%==copy (goto copyProcess)
IF %Command%==xcopy (goto copyProcess)
IF %Command%==shared (goto copyProcess)
IF %Command%==require (goto requireProcess)

echo ERROR: First item in ini file is incorrect.
goto end_repeat_fail

rem
:copyProcess
IF "%AddinName%"=="" (
echo ERROR: Second item in ini file is incorrect.
goto end_repeat_fail)

IF "%FileName%"=="" (
echo ERROR: Third item in ini file is incorrect.
goto end_repeat_fail)

IF %SetupKind%==del (goto delProcess)

rem
IF %Command%==shared set Command=copy

rem
IF %Command%==copy (
 echo:
 echo --- [%AddinName%] [%FileName%] Copying...
 if exist %FileName% echo. > "%FileName%:Zone.Identifier"
 %windir%\system32\xcopy.exe "%FileName%" "%EAInstallPath%" /y /q
)
IF not %errorlevel%==0 (
 echo ERROR: %FileName% copy failed.
 goto end_repeat_fail
)

rem
IF %Command%==xcopy (
 echo:
 echo --- [%AddinName%] [%FileName%] Copying...
 cd /d "%EAInstallPath%"
 mkdir "%FileName%"
 cd "%FileName%"
 %windir%\system32\xcopy.exe "%CurrentPath%\%FileName%" . /y /q
)
IF not %errorlevel%==0 (
 echo ERROR: %FileName% copy failed.
 goto end_repeat_fail
)
cd /d "%CurrentPath%"

rem
IF not "%DLLInfo%"=="" (
 cd /d "%EAInstallPath%"
 IF not exist "%DLLInfo%" (md "%DLLInfo%")
 MOVE /y "%FileName%" "%DLLInfo%"
)
IF not %errorlevel%==0 (
 echo ERROR: %FileName move failed.
 goto end_repeat_fail
)
cd /d "%CurrentPath%"
goto end_repeat

rem
:delProcess
rem
IF %Command%==copy (
 IF %delCounter%==2 (
  echo:
  echo --- [%AddinName%] [%FileName%] Deleting...
  cd /d "%EAInstallPath%"
  IF not "%DLLInfo%"=="" (cd "%DLLInfo%")
  del /F %FileName%
  cd /d "%CurrentPath%"
  goto end_repeat
))

rem
IF %Command%==xcopy (
 IF %delCounter%==2 (
  echo:
  echo --- [%AddinName%] [%FileName%] Deleting...
  cd /d "%EAInstallPath%"
  rmdir /q /s "%FileName%"
  cd /d "%CurrentPath%"
  goto end_repeat
))

goto end_repeat

rem
:requireProcess
IF %SkipRequireProcess%==0 (
 IF %EABuild% lss %AddinName% (
  echo ERROR: Require EA build %AddinName% or later.
  cd /d "%CurrentPath%"
  set result=2
  exit /b 0
))

goto end_repeat

rem
:regProcess
rem
IF %SetupKind%==del (
 IF %delCounter%==2 (goto end_repeat)
)
IF "%AddinName%"=="" (
 echo ERROR: Second item in ini file is incorrect.
 goto end_repeat_fail
)
IF "%FileName%"=="" (
 echo ERROR: Third item in ini file is incorrect.
 goto end_repeat_fail
)
IF "%DLLInfo%"=="" (
 echo ERROR: Fourth item in ini file is incorrect.
 goto end_repeat_fail
)
IF "%RegValue%"=="" (
 echo ERROR: Fifth item in ini file is incorrect.
 goto end_repeat_fail
)

rem
echo ------------------------------------------
echo [%AddinName%] %Message%
echo ------------------------------------------
rem
IF %SetupKind%==add (
IF not "%NoCopy%"=="-" (
 %windir%\system32\xcopy.exe "%FileName%" "%EAInstallPath%" /y /q
))
IF not %errorlevel%==0 (
 echo ERROR: %FileName% copy failed.
 goto end_repeat_fail
)

rem
IF "%DLLInfo%"==".Net" (goto DotNetReg)
IF "%DLLInfo%"==".Net2.0" (goto :DotNetRegNext)
IF "%DLLInfo%"==".Net4.0" (goto :DotNetRegNext)
IF "%DLLInfo%"=="not.Net" (goto notDotNetReg)

echo ERROR: Fourth item in ini file is incorrect.
goto end_repeat_fail

:DotNetReg
rem
ver | find "Version 5.2." > nul
IF not errorlevel 1 goto DotNetRegNext
ver | find "Version 6.0." > nul
IF not errorlevel 1 goto DotNetRegNext
ver | find "Version 6.1." > nul
IF not errorlevel 1 goto DotNetRegNext

if %EAVersion% lss 14 set DLLInfo=.Net4.0

:DotNetRegNext
IF %SetupKind%==add (
 IF not "%DLLInfo%"==".Net4.0" (
  IF %EAVersion% geq 14 (
   echo ERROR: This bat not support .Net 3.5 or earlier addin install to EA 14 or later.
   goto end_repeat_fail
  )
 )
)

rem
IF "%DLLInfo%"==".Net4.0" (
 set DotNetRegasm=%SystemRoot%\Microsoft.NET\Framework\v4.0.30319\regasm.exe
) ELSE (
 set DotNetRegasm=%SystemRoot%\Microsoft.NET\Framework\v2.0.50727\regasm.exe
)

IF not EXIST "%DotNetRegasm%" (
 echo ERROR: .NET Framework not found.
 goto end_repeat_fail
)

cd /d "%EAInstallPath%"
IF %SetupKind%==add (
 echo. > "%FileName%:Zone.Identifier"
 "%DotNetRegasm%" "%FileName%"
) ELSE (
 "%DotNetRegasm%" /unregister "%FileName%"
)
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  echo ERROR: %FileName% regasm is failed.
  goto end_repeat_fail
 ) ELSE (
  echo WARNING: %FileName% regasm is failed.
))
cd /d "%CurrentPath%"
goto regImport

cd /d "%CurrentPath%"
goto regImport

:notDotNetReg
cd /d "%EAInstallPath%"
IF %SetupKind%==add (
 echo. > "%FileName%:Zone.Identifier"
 %windir%\system32\regsvr32.exe /s "%FileName%"
) ELSE (
 %windir%\system32\regsvr32.exe /u /s "%FileName%"
)
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  echo ERROR: %FileName% regsvr32 is failed.
  goto end_repeat_fail
 ) ELSE (
  echo WARNING: %FileName% regsvr32 is failed.
))
cd /d "%CurrentPath%"
goto regImport

rem
:regImport
set RegistoryPath="\Software\Sparx Systems\EAAddins"\%AddinName%

IF EXIST "%SystemRoot%\syswow64\reg.exe" (
 set RegExeFolder="%SystemRoot%\syswow64"
) ELSE (
 set RegExeFolder="%SystemRoot%\system32"
)

IF not "%RegValue%"=="-" (
 IF %SetupKind%==add (
  %RegExeFolder%\reg.exe add HKLM%RegistoryPath% /ve /f /d %RegValue%
 ) ELSE (
   IF %delCounter%==1 (%RegExeFolder%\reg.exe DELETE HKLM%RegistoryPath% /f)
))
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  goto end_repeat_fail
 ) ELSE (
  echo WARNING: Registry is already deleted.
))

IF not "%RegValue%"=="-" (
 IF %SetupKind%==del (
  IF %delCounter%==1 (%RegExeFolder%\reg.exe DELETE HKCU%RegistoryPath% /f > nul 2>&1 )
))

rem
IF %SetupKind%==del (
 IF not "%NoCopy%"=="-" (
  cd /d "%EAInstallPath%"
  del %FileName% /f
))
IF not %errorlevel%==0 (echo WARNING: File is already deleted.)
cd /d "%CurrentPath%"

:end_repeat
exit /b 0

:end_repeat_fail
cd /d "%CurrentPath%"
set result=1
exit /b 0

:err1
echo ERROR: EA Install path not found.
echo Troubleshooting https://www.sparxsystems.jp/en/EAAddinSetupEn.htm#trouble
set result=1
pause
exit /b %result%

:err2
echo ERROR: Permission denied. Please start [Run as administrator].
set result=1
pause
exit /b %result%
